"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _react = _interopRequireDefault(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react2 = require("@iconify/react");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { "default": e }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
var TableRow = function TableRow(_ref) {
  var _checkboxes$index;
  var index = _ref.index,
    checkbox = _ref.checkbox,
    checkboxes = _ref.checkboxes,
    handleCheckBox = _ref.handleCheckBox,
    expandable = _ref.expandable,
    highlightRowOnHover = _ref.highlightRowOnHover,
    expandableCondition = _ref.expandableCondition,
    expandableComponent = _ref.expandableComponent,
    columns = _ref.columns,
    item = _ref.item,
    handleShowPopup = _ref.handleShowPopup,
    visibleColumns = _ref.visibleColumns;
  var rowClassName = "px-6 py-4 whitespace-nowrap text-sm font-medium text-gray-900 border-b-[1px] border-solid";
  var _React$useState = _react["default"].useState({}),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    expandedRows = _React$useState2[0],
    setExpandedRows = _React$useState2[1];
  var toggleRowExpand = _react["default"].useCallback(function (index) {
    setExpandedRows(function (prevState) {
      return _objectSpread(_objectSpread({}, prevState), {}, _defineProperty({}, index, !prevState[index]));
    });
  }, []);
  var handleColumnClick = _react["default"].useCallback(function (column, data) {
    if (column.showPopupOnClick) {
      if (typeof data === 'string') {
        handleShowPopup({
          show: true,
          title: column.header,
          content: data
        });
      } else if (_typeof(data) === 'object') {
        var _data$props;
        if (data !== null && data !== void 0 && (_data$props = data.props) !== null && _data$props !== void 0 && _data$props.children) {
          handleShowPopup({
            show: true,
            title: column.header,
            content: data.props.children
          });
        }
      }
    }
  }, [handleShowPopup]);
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("tr", {
    key: index,
    className: "relative ".concat(highlightRowOnHover ? 'hover:bg-gray-100' : '')
  }, expandable && (expandableCondition === undefined || expandableCondition(item) ? /*#__PURE__*/_react["default"].createElement("td", {
    className: rowClassName
  }, /*#__PURE__*/_react["default"].createElement("span", {
    title: "Click to expand",
    className: "cursor-pointer",
    onClick: function onClick() {
      return toggleRowExpand(index);
    }
  }, /*#__PURE__*/_react["default"].createElement(_react2.Icon, {
    fontSize: "25px",
    icon: expandedRows[index] ? 'material-symbols:keyboard-arrow-down' : 'material-symbols:keyboard-arrow-right'
  }))) : /*#__PURE__*/_react["default"].createElement("td", {
    className: 'border-b-[1px] border-solid'
  })), checkbox && /*#__PURE__*/_react["default"].createElement("td", {
    className: rowClassName
  }, /*#__PURE__*/_react["default"].createElement("input", {
    type: 'checkbox',
    checked: ((_checkboxes$index = checkboxes[index]) === null || _checkboxes$index === void 0 ? void 0 : _checkboxes$index.checked) || false,
    onChange: function onChange(e) {
      return handleCheckBox(index, e.target.checked);
    },
    name: 'datatable-checkbox',
    title: 'Select'
  })), columns.map(function (col, index) {
    var value = typeof col.selector === 'string' ? col.selector.split('.').reduce(function (acc, key) {
      return acc[key];
    }, item) : col.selector(item);
    return visibleColumns[index] && /*#__PURE__*/_react["default"].createElement("td", {
      key: col.selector.toString(),
      onClick: function onClick() {
        return handleColumnClick(col, value);
      },
      style: _objectSpread(_objectSpread({}, col.style), col.rowStyle),
      className: rowClassName + " ".concat(col.showPopupOnClick ? 'cursor-pointer' : ''),
      title: "".concat(col.showPopupOnClick ? 'Click to view more' : '')
    }, value ? value : '-');
  })), expandable && /*#__PURE__*/_react["default"].createElement("tr", {
    className: "expandable-row ".concat(expandedRows[index] ? 'expanded' : 'collapsed')
  }, /*#__PURE__*/_react["default"].createElement("td", {
    colSpan: columns.length + 1,
    className: "p-4"
  }, expandedRows[index] && expandableComponent ? expandableComponent(item) : null)));
};
TableRow.propTypes = {
  index: _propTypes["default"].number.isRequired,
  checkbox: _propTypes["default"].bool,
  checkboxes: _propTypes["default"].array.isRequired,
  handleCheckBox: _propTypes["default"].func.isRequired,
  expandable: _propTypes["default"].bool,
  highlightRowOnHover: _propTypes["default"].bool,
  expandableCondition: _propTypes["default"].func,
  expandableComponent: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].element]),
  columns: _propTypes["default"].array.isRequired,
  item: _propTypes["default"].object.isRequired,
  handleShowPopup: _propTypes["default"].func.isRequired,
  visibleColumns: _propTypes["default"].array
};
var _default = exports["default"] = TableRow;